﻿using Syncfusion.SfDataGrid.XForms;
using Xamarin.Forms;

namespace DataGridExample.CustomRenderer
{
    public class CustomGridCellTemplateRenderer : GridVirtualizingCellRenderer<View, View>
    {
        public CustomGridCellTemplateRenderer()
        {
            SupportsRenderOptimization = true;
        }

        public override void OnInitializeDisplayView(DataColumnBase dataColumn, View view)
        {
            base.OnInitializeDisplayView(dataColumn, view);
            //TODO: Why is this a label?
            var v = (SfLabel)view;
            v.BackgroundColor = Color.Green;

            ApplyDisplayDataTemplate(view, (GridTemplateColumn)dataColumn.GridColumn, dataColumn);
        }
        
        private void ApplyDisplayDataTemplate(View view, GridTemplateColumn templateColumn, object dataContext)
        {
            DataTemplate template = null;

            if (templateColumn.CellTemplateSelector != null)
                template = templateColumn.CellTemplateSelector.SelectTemplate(dataContext, view);

            if (template == null && templateColumn.CellTemplate != null)
                template = templateColumn.CellTemplate;

            view.SetBinding(BindableProperty.Create("Text", typeof(string), typeof(string)), templateColumn.MappingName);
        }
    }
}
