﻿using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Diagnostics;

namespace DataGridExample.ViewModels
{
    public class Thing
    {
        public Thing() : this("unknown", 0, false, null) {}
        public Thing(string name, int number, bool success, IEnumerable<string> codes)
        {
            Name = name;
            Number = number;
            Success = success;
            _jobCodes = new ObservableCollection<JobCode>();
            var rand = new Random(Number);
            foreach (var code in codes)
            {
                var val = rand.Next(0, 100);
                var special = (val % 2 == 0);
                Debug.WriteLine($"Thing {name}: {code}={val}");
                //_jobCodes.Add(val);
                _jobCodes.Add(new JobCode() { Code = code, Special = special, Value = val.ToString() });
            }
        }
        public string Name { get; set; }
        public int Number { get; private set; }
        public bool Success { get; private set; }

        private ObservableCollection<JobCode> _jobCodes;
        public ObservableCollection<JobCode> JobCodeCollection
        {
            get { return _jobCodes; }
            set { this._jobCodes = value; }
        }
    }
}